<?php

## Tasks Functions
##
## Handles the questions which pertain to the Tasks table;
## not used for routine Xortoth useage, but rather in
## conjunction of the scheduler daemon, Xuru.

function q_task_list()
{
	global $question_root,$data_node;
	
	$status_node=find_grandchild($question_root,"Data","Status");
	if (!$status_node) {add_error("Data/Status node not supplied."); return;}
	$status=get_text($status_node);
	
	if ($status=="" || $status=="All") 
		$query="SELECT Key_Task,Status,Priority,Path,Action FROM Tasks ORDER BY Status,0-Priority,Key_Task";
		else
		$query="SELECT Key_Task,Status,Priority,Path,Action FROM Tasks WHERE Status='$status' ORDER BY 0-Priority,Key_Task";

	$result=mysql_query($query);
	$num=mysql_numrows($result);

	for($n=0;$n<$num;$n++)
	{
		$key=mysql_result($result,$n,"Key_Task");
		$status=mysql_result($result,$n,"Status");
		$priority=mysql_result($result,$n,"Priority");

		$node=$data_node->new_child("Task","");
		$node->new_child("Key",mysql_result($result,$n,"Key_Task"));
		$node->new_child("Status",mysql_result($result,$n,"Status"));
		$node->new_child("Priority",mysql_result($result,$n,"Priority"));
		$node->new_child("Path",mysql_result($result,$n,"Path"));
		$node->new_child("Action",mysql_result($result,$n,"Action"));
	}
}

function q_task_fetch()
{
	global $question_root,$data_node;
	
	$key_node=find_grandchild($question_root,"Data","Key");
	if (!$key_node) {add_error("Data/Key node not supplied."); return;}
	$key=get_text($key_node);
	
	$query="SELECT * FROM Tasks WHERE Key_Task=$key";
	$result=mysql_query($query);
	if (mysql_numrows($result)>0)
	{
		$data_node->new_child("Key",mysql_result($result,0,"Key_Task"));
		$data_node->new_child("Path",mysql_result($result,0,"Path"));
		$data_node->new_child("Status",mysql_result($result,0,"Status"));
		$data_node->new_child("Action",mysql_result($result,0,"Action"));
		$data_node->new_child("Threads",mysql_result($result,0,"Threads"));
		$data_node->new_child("Priority",mysql_result($result,0,"Priority"));
		$data_node->new_child("Requestor",mysql_result($result,0,"Requestor"));
		$data_node->new_child("Possessor",mysql_result($result,0,"Possessor"));
		$data_node->new_child("RequestDate",mysql_result($result,0,"RequestDate"));
		$data_node->new_child("StartDate",mysql_result($result,0,"StartDate"));
		$data_node->new_child("FinishDate",mysql_result($result,0,"FinishDate"));
		$data_node->new_child("TickDate",mysql_result($result,0,"TickDate"));
	} 
	else add_error("Task key not found."); 	
}

function q_task_new()
{
	global $question_root,$data_node;
	
	$path=grandchild_or_error($question_root,"Data","Path"); if ($path=="@") return;
	$action=grandchild_or_error($question_root,"Data","Action"); if ($action=="@") return;
	$threads=grandchild_or_error($question_root,"Data","Threads"); if ($threads=="@") return;
	$priority=grandchild_or_error($question_root,"Data","Priority"); if ($priority=="@") return;
	
	$path=sql_text($path); $action=sql_text($action);
	$query="SELECT 1 FROM Tasks WHERE Path='$path' AND Action='$action' AND (Status='Idle' OR Status='Active' OR Status='Paused')";
	$result=mysql_query($query);
	if (mysql_numrows($result)>0)
	{
		add_error("Cannot schedule task for given path because an active/awaiting task already exists.");
		return;
	}
	
	$key_data=find_data_path($path);
	if ($key_data==0) {add_error("Path [$path] does not correspond to a property."); return;}
	$query="SELECT Type FROM Data WHERE Key_Data=$key_data";
	$result=mysql_query($query);
	if (mysql_numrows($result)==0 || mysql_result($result,0,"Type")!="CompParams")
		{add_error("Path must correspond to a property of type CompParams."); return;}
	
	if ($action=="") $action="Xentark";
	if ($threads!='Multi') $threads="Single";
	if ($priority<-10) $priority=-10;
	if ($priority>10) $priority=10;
	
	$query="INSERT INTO Tasks (Path,Status,Action,Threads,Priority,Requestor,RequestDate) ".
	       "VALUES ('$path','Idle','$action','$threads',$priority,'nobody',NOW())";
	mysql_query($query);

	$key=mysql_insert_id();
	$data_node->new_child("Key",$key);
	$data_node->new_child("Success","");
}

function q_task_delete()
{
	global $question_root,$data_node;

	$key_node=find_grandchild($question_root,"Data","Key");
	if (!$key_node) {add_error("Data/Key node not supplied."); return;}
	$key=get_text($key_node);
	
	$query="SELECT 1 FROM Tasks WHERE Key_Task=$key";
	$result=mysql_query($query);
	if (mysql_numrows($result)==0) {add_error("Task key not found."); return;}
	
	$query="DELETE FROM Tasks WHERE Key_Task=$key";
	$result=mysql_query($query);
	
	$data_node->new_child("Success","");	
}

function q_task_claim()
{
	global $question_root,$data_node;
	
	$key_node=find_grandchild($question_root,"Data","Key");
	if (!$key_node) {add_error("Data/Key node not supplied."); return;}
	$key=get_text($key_node);
	$xurunode=clean_text(grandchild_or_error($question_root,"Data","XuruNode")); if ($xurunode=="@") return;
	
	mysql_query("LOCK TABLES Tasks WRITE");
	
	$query="SELECT Status,Threads,Action,Requestor,StartDate FROM Tasks WHERE Key_Task=$key";
	$result=mysql_query($query);
	if (mysql_numrows($result)==0) 
	{
		add_error("Task key not found / may have been purged."); 
		mysql_query("UNLOCK TABLES Tasks WRITE");
		return;
	}
	$status=mysql_result($result,0,"Status");
	if ($status!="Idle" && $status!="Paused")
	{
		add_error("Task is no longer available / may have been claimed."); 
		mysql_query("UNLOCK TABLES Tasks WRITE");
		return;
	}
	
	$data_node->new_child("Success","");
	
	$query="UPDATE Tasks SET Status='Active',Possessor='$xurunode',StartDate=NOW() WHERE Key_Task=$key";
	mysql_query($query);
	
	mysql_query("UNLOCK TABLES Tasks WRITE");
}

function q_task_cancel()
{
	global $question_root,$data_node;
	
	$key_node=find_grandchild($question_root,"Data","Key");
	if (!$key_node) {add_error("Data/Key node not supplied."); return;}
	$key=get_text($key_node);

	change_task_status($key,"Cancelled");
}

function q_task_complete()
{
	global $question_root,$data_node;
	
	$key_node=find_grandchild($question_root,"Data","Key");
	if (!$key_node) {add_error("Data/Key node not supplied."); return;}
	$key=get_text($key_node);

	change_task_status($key,"Done");
}

function q_task_pause()
{
	global $question_root,$data_node;
	
	$key_node=find_grandchild($question_root,"Data","Key");
	if (!$key_node) {add_error("Data/Key node not supplied."); return;}
	$key=get_text($key_node);

	change_task_status($key,"Paused");
}

function q_task_tick()
{
	global $question_root,$data_node;
	
	$key_node=find_grandchild($question_root,"Data","Key");
	if (!$key_node) {add_error("Data/Key node not supplied."); return;}
	$key=get_text($key_node);
	
	mysql_query("LOCK TABLES Tasks WRITE");
	
	$query="SELECT Status,Threads,Action,Requestor,StartDate FROM Tasks WHERE Key_Task=$key";
	$result=mysql_query($query);
	if (mysql_numrows($result)==0) 
	{
		add_error("Task key not found / may have been purged."); 
		mysql_query("UNLOCK TABLES Tasks WRITE");
		return;
	}
	$status=mysql_result($result,0,"Status");
	if ($status!="Active")
	{
		add_error("Task is not currently marked as active."); 
		mysql_query("UNLOCK TABLES Tasks WRITE");
		return;
	}
	
	$data_node->new_child("Success","");
	
	$query="UPDATE Tasks SET TickDate=NOW() WHERE Key_Task=$key";
	mysql_query($query);
	
	mysql_query("UNLOCK TABLES Tasks WRITE");
}

function q_task_priority()
{
	global $question_root,$data_node;

	$key_node=find_grandchild($question_root,"Data","Key");
	if (!$key_node) {add_error("Data/Key node not supplied."); return;}
	$key=get_text($key_node);
	
	$key=grandchild_or_error($question_root,"Data","Key"); if ($key=="@" || $key<1) return;
	$priority=grandchild_or_error($question_root,"Data","Priority"); if ($priority=="@") return;
	
	if ($priority<-10) $priority=-10;
	if ($priority>10) $priority=10;

	$query="SELECT 1 FROM Tasks WHERE Key_Task=$key";
	$result=mysql_query($query);
	if (mysql_numrows($result)==0) {add_error("Task key not found."); return;}
	
	$query="UPDATE Tasks SET Priority=$priority WHERE Key_Task=$key";
	$result=mysql_query($query);
	
	$data_node->new_child("Success","");	
}

function q_task_changepath()
{
	global $question_root,$data_node;

	$key_node=find_grandchild($question_root,"Data","Key");
	if (!$key_node) {add_error("Data/Key node not supplied."); return;}
	$key=get_text($key_node);
	
	$key=grandchild_or_error($question_root,"Data","Key"); if ($key=="@" || $key<1) return;
	$newpath=grandchild_or_error($question_root,"Data","Path"); if ($newpath=="@") return;
	$newpath=sql_text($newpath);
	
	$query="SELECT 1 FROM Tasks WHERE Key_Task=$key";
	$result=mysql_query($query);
	if (mysql_numrows($result)==0) {add_error("Task key not found."); return;}
	
	$query="UPDATE Tasks SET Path='$newpath' WHERE Key_Task=$key";
	$result=mysql_query($query);
	
	$data_node->new_child("Success","");	
}

	function change_task_status($key,$new_status)
	{
		global $question_root,$data_node;

		mysql_query("LOCK TABLES Tasks WRITE");

		$query="SELECT Status FROM Tasks WHERE Key_Task=$key";
		$result=mysql_query($query);
		if (mysql_numrows($result)==0) 
		{
			add_error("Task key not found / may have been purged."); 
			mysql_query("UNLOCK TABLES Tasks WRITE");
			return;
		}
		$status=mysql_result($result,0,"Status");
		if ($status!="Active")
		{
			add_error("Task is not active, cannot be set to $new_status."); 
			mysql_query("UNLOCK TABLES Tasks WRITE");
			return;
		}

		$data_node->new_child("Success","");

		$query="UPDATE Tasks SET Status='$new_status' WHERE Key_Task=$key";
		mysql_query($query);

		mysql_query("UNLOCK TABLES Tasks WRITE");
	}


?>
